/* Proyecto Juego del Ahorcado */

#include<stdio.h>
#include<conio.h>
#include<stdlib.h>
#include<string.h>
#include<ctype.h>
#include<dos.h>

typedef struct
{
char nombre[50];
int  puntos;
}Ficha;

void presentacion(void);
void menu(int *opc);              /* Aqu dividimos el programa por partes */
void menu_avanzado(void);
void anadir(void);
void borrar(void);
void ver(void);
void palabra(void);
void puntuacion(void);
void jugar(Ficha jugador);
void nombre(void);
void pantalla_juego(void);
void juego_nuevo(void);
void cargar_juego(void);
void fallo(void);

int posicion=0;

void main()
{
	int opcion;

	presentacion();  //Llama a la presentacin
	do
	{
		menu(&opcion);   //Llama al men y nos devuelve la opcion escogida


		switch(opcion)
		{
			case 1: juego_nuevo();break;     //Podriamos haber hecho esto en la funcion menu
			case 2: cargar_juego();break;    //pero aqu lo controlamos mejor
			case 3: puntuacion();break;
			case 4: menu_avanzado();break;
		}

	}
	while(opcion<5); //si es 5 termina el programa


}


void juego_nuevo(void)
{
	FILE *fichero_nombres;
	FILE *fichero;

	long grandaria;
	char entra_nombre[50];   //nombre de jugador
	char palabra[50];
	int nombre_ocupado,intentos=0;    //controlador
	Ficha datos;

	fichero=fopen("palabras.dat","rb");//esto es solo para comprobar si hay palabras

	fseek(fichero,0,SEEK_END);
	grandaria=ftell(fichero)/sizeof(palabra);
	if(grandaria==0) //antes que nada miramos si hay o no hay palabras
	{
		clrscr();
		textcolor(5);
		gotoxy(24,13);
		cprintf("No hay palabras registradas");
		sleep (2);
		fclose(fichero);
		return;
	}

	if((fichero_nombres=fopen("jugadores.dat","a+b"))==NULL)
	{
		printf("no se pudo abrir el fichero de lectura");
		exit(1);
	}
	clrscr();
	do //esta rutina nos comprueba si el nombre est o no est en el fichero de nombres
	{
		nombre_ocupado=0;
		do
		{
			nombre(); // Pantalla que nos muestra la solicitud del nombre
			fflush(stdin);
			gotoxy(28,13);scanf("%[^\n]",entra_nombre);
		}
		while(entra_nombre[0]=='\0');
		fread(&datos,sizeof(Ficha),1,fichero_nombres);
		while(!ferror(fichero_nombres) && !feof(fichero_nombres) && nombre_ocupado!=1)
		{
			//printf("\n%s y %d",datos.nombre,datos.puntos);getch();
			if(strcmp(datos.nombre,entra_nombre)==0)
			{
				nombre_ocupado=1;
			}
			else fread(&datos,sizeof(Ficha),1,fichero_nombres);
		}
		if(nombre_ocupado==1)
		{
			clrscr();
			gotoxy(25,13);
			textcolor(5);
			printf("Nombre ocupado. Prueba con otro");
			sleep(1);
			intentos++;
			rewind(fichero_nombres);
		}
		if(intentos==3)
		{
		fclose(fichero_nombres);
		return;//esto nos controla que no nos quedemos aqu infinitamente(por si no hay nombres)
		}

	}
	while(nombre_ocupado!=0);
	datos.puntos=0;
	//printf("%s",entra_nombre);getch();
	strcpy(datos.nombre,entra_nombre);
	//printf("\n %s %d",datos.nombre,datos.puntos);getch();
	fclose(fichero_nombres);
	/* ya tenemos el nombre, ahora se lo pasamos al juego*/
	jugar(datos);
}


void cargar_juego(void)
{
	FILE *fichero_nombres;
	FILE *fichero;
	FILE *fichero_jugadores;

	char entra_nombre[50];   //nombre de jugador
	char palabra[50];
	long grandaria;
	int nombre_ocupado,intentos=0;    //controlador
	Ficha datos;

	fichero_jugadores=fopen("jugadores.dat","rb");//esto es solo para comprobar si hay jugadores registrados

	fseek(fichero_jugadores,0,SEEK_END);
	grandaria=ftell(fichero_jugadores)/sizeof(palabra);
	if(grandaria==0) //antes que nada miramos si hay o no hay palabras
	{
		clrscr();
		textcolor(5);
		gotoxy(24,13);
		cprintf("No hay jugadores registrados");
		sleep (2);
		fclose(fichero_jugadores);
		return;
	}
	fclose(fichero_jugadores);

	fichero=fopen("palabras.dat","rb");//esto es solo para comprobar si hay palabras

	fseek(fichero,0,SEEK_END);
	grandaria=ftell(fichero)/sizeof(palabra);
	if(grandaria==0) //antes que nada miramos si hay o no hay palabras
	{
		clrscr();
		textcolor(5);
		gotoxy(24,13);
		cprintf("No hay palabras registradas");
		sleep (2);
		fclose(fichero);
		return;
	}

	if((fichero_nombres=fopen("jugadores.dat","a+b"))==NULL)
	{
		printf("no se pudo abrir el fichero de lectura");
		exit(1);
	}
	clrscr();
	do //esta rutina nos comprueba si el nombre est o no est en el fichero de nombres
	{
		nombre_ocupado=0;
		do
		{
			nombre(); // Pantalla que nos muestra la solicitud del nombre
			fflush(stdin);
			gotoxy(28,13);scanf("%[^\n]",entra_nombre);
		}
		while(entra_nombre[0]=='\0');
		fread(&datos,sizeof(Ficha),1,fichero_nombres);
		while(!ferror(fichero_nombres) && !feof(fichero_nombres) && nombre_ocupado!=1)
		{
			if(strcmp(datos.nombre,entra_nombre)==0)
			{
				nombre_ocupado=1;
			}
			else fread(&datos,sizeof(Ficha),1,fichero_nombres);
		}
		if(nombre_ocupado==0)
		{
			clrscr();
			textcolor(5);
			gotoxy(25,13);printf("Nombre no encontrado. Prueba con otro");
			sleep(1);
			intentos++;
			rewind(fichero_nombres);
		}
		if(intentos==3)
		{
		fclose(fichero_nombres);
		return;//esto nos controla que no nos quedemos aqu infinitamente(por si no hay nombres)
		}

	}
	while(nombre_ocupado!=1);
	/* ya tenemos el nombre, ahora se lo pasamos al juego*/

	jugar(datos);

}

void jugar(Ficha jugador)
{
 FILE *fichero;
 FILE *fichero_nombres;
 FILE *temporal;
 char abecedario[]="ABCDEFGHIJKLMNOPQRSTUVWXYZ";//la  o  no son letras,con lo cual hay que ponerlas como caracter
 char caracter,opcion,borrarcaracter;
 char palabra[50];
 long grandaria;
 int fallos=0;
 int x,aciertos,siesta=0,esta=0,p;
 Ficha registros;

 fichero=fopen("palabras.dat","rb");

 fseek(fichero,0,SEEK_END);
 grandaria=ftell(fichero)/sizeof(palabra);
 //calculamos las palabras que hay en el fichero para elegir a continuacion una
 pantalla_juego();
 randomize();
 do
 {




	fseek(fichero,sizeof(palabra)*random(grandaria),SEEK_SET);
	fread(palabra,sizeof(char),50,fichero);

	textcolor(14);
	gotoxy(26,9);cprintf("%s",jugador.nombre);
	gotoxy(26,11);cprintf("%d",jugador.puntos);


	for(x=0;x<strlen(palabra);x++)
	{
	textcolor(14);gotoxy(26+x,15);cprintf("*");
	}
	x=0;
	aciertos=0;
	for(p=0;p<28;p++)
		{
			if(p<15)gotoxy(14+p+p,21);//con esto nos saltamos la '' para que solo salga la 
			else gotoxy(12+p+p,21);
			if(abecedario[p]!='')
				{


					textcolor(5);cprintf("%c",abecedario[p]);
				}
		}


	do
		{
			do
			{

				esta=0;
				do
				{
					_setcursortype(_NORMALCURSOR);
					do
					{
					gotoxy(26,17);
					textcolor(5);
					cprintf("INTRODUCE LETRA:          ");
					gotoxy(43,17);
					fflush(stdin);
					caracter=toupper(getche());
					if(caracter=='') caracter='';//la pasamos a mayusculas
					_setcursortype(_NOCURSOR);
					borrarcaracter=getch();
					_setcursortype(_NORMALCURSOR);
					}
					while(borrarcaracter=='\b');//controlamos el borrado del caracter
				}
				while(!isupper(caracter) && caracter!='');
				x=0;
				while(abecedario[x]!='\0')
				{
					if(abecedario[x]==caracter)
					{
						esta=1;
						abecedario[x]='*';
						if(caracter=='')
						{
							abecedario[x+1]='*';
						}
					}
					x++;
				}
				x=0;
				if(esta==0)
				{
				gotoxy(25,17);
				_setcursortype(_NOCURSOR);
				textcolor(5);
				cprintf("Letra introducida anteriormente");
				sleep(1);
				gotoxy(25,17);
				printf("                               ");
				}

			}
			while(esta!=1);
			while(x<=strlen(palabra))
			{
				if(palabra[x]==caracter)
				{
					textcolor(0);gotoxy(26+x,15);cprintf("%c",caracter);
					siesta=1;
					aciertos++;
				}
				x++;
			}

			if(siesta==0)
			{
				fallos++;
				fallo();
			}
			siesta=0;
			for(p=0;p<27;p++)
				{
					if(p<15)gotoxy(14+p+p,21);//con esto nos saltamos la '' para que solo salga la 
					else gotoxy(12+p+p,21);
					if(abecedario[p]!='')
						{
							if(abecedario[p]!='*')
					{
						textcolor(5);
					}
					else textcolor(14);
							cprintf("%c",abecedario[p]);
						}
				}
		}
		while(fallos<8 && aciertos<strlen(palabra));
		gotoxy(26,17);printf("                  ");
		_setcursortype(_NOCURSOR);



		if(fallos==8)
		{
			textcolor(5);
			gotoxy(26,17);cprintf("Has perdido");
			sleep(2);
			gotoxy(26,17);printf("           ");
		}
		if (aciertos==strlen(palabra))
		{
			textcolor(5);
			gotoxy(26,17);cprintf("Has ganado");
			jugador.puntos++;

			textcolor(14);
			gotoxy(26,11);cprintf("%d",jugador.puntos);

			sleep(2);
			gotoxy(26,17);printf("             ");//limpiamos la frase


		}

		for(x=0;x<strlen(palabra);x++)
		{
			gotoxy(26+x,15);printf(" ");
		}
		_setcursortype(_NORMALCURSOR);
		do
		{


			do
			{
				do
				{
				textcolor(5);
				gotoxy(25,17);cprintf("Quieres seguir jugando?[s/n]:  ");
				gotoxy(56,17);
				opcion=toupper(getche());
				_setcursortype(_NOCURSOR);
				borrarcaracter=getch();
				_setcursortype(_NORMALCURSOR);
				}
				while(borrarcaracter=='\b');//controlamos el borrado

			}
			while(opcion!='S' && opcion!='N');
			_setcursortype(_NOCURSOR);
			//getch();//mas que nada es por ver la opcion que hemos elegido
			gotoxy(25,17);printf("                                ");
		}
		while(opcion!='N' && opcion!='S');
		if(opcion=='S')
		{
			gotoxy(38,6);printf("AHORCADO"); // reponemos la palabra
			strcpy(abecedario,"ABCDEFGHIJKLMNOPQRSTUVWXYZ");
			fallos=0;
		}
		posicion=0;
 }
 while(opcion!='N');

 fichero_nombres=fopen("jugadores.dat","a+b");
 temporal=fopen("temporal","wb");
 fread(&registros,sizeof(Ficha),1,fichero_nombres);
 while(!ferror(fichero_nombres) && !feof(fichero_nombres))
 {
	if(strcmp(registros.nombre,jugador.nombre)!=0)
	{
		fwrite(&registros,sizeof(Ficha),1,temporal);
	}
	fread(&registros,sizeof(Ficha),1,fichero_nombres);
 }
 fwrite(&jugador,sizeof(Ficha),1,temporal);

 fclose(temporal);
 fclose(fichero_nombres);
 fclose(fichero);
 remove("jugadores.dat");
 rename("temporal","jugadores.dat");
}





















void menu(int *opc)

{
	 char elegir;


	 textattr( 56 );
	 clrscr();
	 textattr( 53 );
	 gotoxy( 30, 4 );
	 cputs( "Ŀ" );
	 textattr( 48 );
	 gotoxy( 24, 5 );
	 cputs( "      " );
	 textattr( 53 );
	 gotoxy( 30, 5 );
	 cputs( "" );
	 textattr( 62 );
	 gotoxy( 32, 5 );
	 cputs( "EL AHORCADO" );
	 textattr( 48 );
	 gotoxy( 43, 5 );
	 cputs( " " );
	 textattr( 53 );
	 gotoxy( 44, 5 );
	 cputs( "" );
	 textattr( 48 );
	 gotoxy( 45, 5 );
	 cputs( " " );
	 textattr( 53 );
	 gotoxy( 30, 6 );
	 cputs( "" );
	 textattr( 48 );
	 gotoxy( 28, 9 );
	 cputs( "(" );
	 textattr( 49 );
	 gotoxy( 29, 9 );
	 cputs( "N" );
	 textattr( 48 );
	 gotoxy( 30, 9 );
	 cputs( ")UEVA PARTIDA" );
	 textattr( 63 );
	 gotoxy( 80, 9 );
	 cputs( " " );
	 textattr( 48 );
	 gotoxy( 28, 11 );
	 cputs( "(" );
	 textattr( 49 );
	 gotoxy( 29, 11 );
	 cputs( "C" );
	 textattr( 48 );
	 gotoxy( 30, 11 );
	 cputs( ")ARGAR PARTIDA" );
	 gotoxy( 28, 13 );
	 cputs( "(" );
	 textattr( 49 );
	 gotoxy( 29, 13 );
	 cputs( "V" );
	 textattr( 48 );
	 gotoxy( 30, 13 );
	 cputs( ")ER PUNTUACIONES" );
	 gotoxy( 28, 15 );
	 cputs( "(" );
	 textattr( 49 );
	 gotoxy( 29, 15 );
	 cputs( "O" );
	 textattr( 48 );
	 gotoxy( 30, 15 );
	 cputs( ")PCIONES AVANZADAS" );
	 textattr( 49 );
	 gotoxy( 80, 15 );
	 cputs( " " );
	 textattr( 48 );
	 gotoxy( 28, 17 );
	 cputs( "(" );
	 textattr( 49 );
	 gotoxy( 29, 17 );
	 cputs( "S" );
	 textattr( 48 );
	 gotoxy( 30, 17 );
	 cputs( ")ALIR" );
	 gotoxy( 23, 20 );
	 cputs( "    " );
	 textattr( 94 );
	 gotoxy( 28, 20 );
	 cputs( " MENU DE OPCIONES " );
	 textattr( 48 );
	 gotoxy( 80, 20 );
	 cputs( " " );

	 do
		{
		_setcursortype(_NOCURSOR);
		elegir=toupper(getch());
		 switch(elegir)
			{
			case 'N':*opc=1;break;
			case 'C':*opc=2;break;
			case 'V':*opc=3;break;
			case 'O':*opc=4;break;
			case 'S':*opc=5;break;
			default :*opc=0;
			}
		}
	 while(*opc<1);

}




void menu_avanzado(void)
{

char opcion;
int elegir;

do
  {
	 clrscr();
	 textattr( 53 );
	 gotoxy( 30, 4 );
	 cputs( "Ŀ" );
	 textattr( 53 );
	 gotoxy( 30, 5 );
	 cputs( "" );
	 textattr( 62 );
	 gotoxy( 32, 5 );
	 cputs( "EL AHORCADO" );
	 textattr( 53 );
	 gotoxy( 44, 5 );
	 cputs( "" );
	 textattr( 53 );
	 gotoxy( 30, 6 );
	 cputs( "" );
	 textattr( 48 );
	 gotoxy( 28, 9 );
	 cputs( "(" );
	 textattr( 49 );
	 gotoxy( 29, 9 );
	 cputs( "A" );
	 textattr( 48 );
	 gotoxy( 30, 9 );
	 cputs( ")ADIR PALABRAS" );
	 textattr( 48 );
	 gotoxy( 28, 11 );
	 cputs( "(" );
	 textattr( 49 );
	 gotoxy( 29, 11 );
	 cputs( "B" );
	 textattr( 48 );
	 gotoxy( 30, 11 );
	 cputs( ")ORRAR PALABRAS" );
	 gotoxy( 28, 13 );
	 cputs( "(" );
	 textattr( 49 );
	 gotoxy( 29, 13 );
	 cputs( "V" );
	 textattr( 48 );
	 gotoxy( 30, 13 );
	 cputs( ")ER PALABRAS     " );
	 gotoxy( 28, 15 );
	 cputs( "(" );
	 textattr( 49 );
	 gotoxy( 29, 15 );
	 cputs( "S" );
	 textattr( 48 );
	 gotoxy( 30, 15 );
	 cputs( ")ALIR" );
	 textattr( 94 );
	 gotoxy( 23, 20 );
	 cputs( " MENU DE OPCIONES AVANZADAS " );

	 do
	 {
		_setcursortype(_NOCURSOR);
		opcion=toupper(getch());

		switch (opcion)
		{
			case 'A':elegir=1;break;
			case 'B':elegir=2;break;
			case 'V':elegir=3;break;
			case 'S':elegir=4;break;
			default :elegir=0;
		}
	 }
	 while(elegir<1);



	 if(elegir==1) anadir();
	 if(elegir==2) borrar();
	 if(elegir==3) ver();

   }
   while(elegir!=4);

}




void anadir(void)
{
 FILE *fichero;

 char entra_palabra[50];
 char busca_palabra[50];
 char opci,borrarcaracter,comprobar;
 int x,i,p;

 textattr( 56 );
  do
  {
  for(i=0;i<50;i++)
	{
	entra_palabra[i]='\0';
	busca_palabra[i]='\0';
	}


  if((fichero=fopen("palabras.dat","a+b"))==NULL)
	 {
		printf("\nNO SE PUEDE ABRIR EL FICHERO");
		getch();
		exit(1);
	 }
  x=0;
  do
  {
  p=0;
  comprobar=0;
	do
	{
		palabra(); //llamamos a la funcion palabra para obtener su pantallita
		fflush(stdin);
		gotoxy(28,13);scanf("%[^\n]",entra_palabra);
	}
	while(entra_palabra[0]=='\0');

  while(entra_palabra[p]!='\0')//las pasamos a mayusculas
  {

	entra_palabra[p]=toupper(entra_palabra[p]);

	if(entra_palabra[p]=='') entra_palabra[p]='';//la pasamos a mayusculas

	if(!isalpha(entra_palabra[p]) && entra_palabra[p]!='')
	{
	clrscr();
	gotoxy(15,13);printf("No pueden haber espacios ni caracteres en la palabra");
	sleep(2);
	comprobar=1;
	entra_palabra[p]='\0';
	}
	else p++;
  }
  }
  while(comprobar!=0);
  fread(busca_palabra,sizeof(char),50,fichero);
  while(!feof(fichero) && x!=1)
	  {

	  if(strcmp(entra_palabra,busca_palabra)==0)
		{
		clrscr();
		gotoxy(22,13);printf("Esta palabra ya existe en el fichero");
		x=1;//nos sirve de comprobacion para ver si est o no
		sleep(1);
		}
	  fread(busca_palabra,sizeof(char),50,fichero);
	  }
  if(x==0)
		{
		fwrite(entra_palabra,sizeof(char),50,fichero);

		fclose(fichero);
		clrscr();
		gotoxy(22,13);printf("La palabra se ha aadido con xito");
		sleep(2);

		}
  else
		{
		fclose(fichero);
		}

   do
	{
	clrscr();
		do
		{
		gotoxy(22,13);printf("Quieres aadir otra palabra[s/n]?:   ");
		fflush(stdin);
		gotoxy(58,13);
		_setcursortype(_NORMALCURSOR);
		opci=toupper(getche());
		_setcursortype(_NOCURSOR);
		borrarcaracter=getch();
		}
		while(borrarcaracter=='\b');//controlamos el borrado
	}
	while(opci!='S' && opci!='N' );
  }
  while(opci!='N');



}



void borrar(void)
{
  FILE *fichero;
  FILE *temporal;


  char entra_palabra[50];
  char busca_palabra[50];
  char opci,borrarcaracter;
  int i,comprobar=0;

  textattr( 56 );textattr( 56 );
  do
  {
  comprobar=0;
  for(i=0;i<50;i++)
	{
	entra_palabra[i]='\0';
	busca_palabra[i]='\0';
	}


  if((fichero=fopen("palabras.dat","a+b"))==NULL)
	 {
		printf("\nNO SE PUEDE ABRIR EL FICHERO");
		getch();
		exit(1);
	 }
  if((temporal=fopen("temporal","w+b"))==NULL)
	 {
		printf("\nNO SE PUEDE ABRIR EL FICHERO TEMPORAL");
		getch();
		exit(1);
	 }
	 fread(busca_palabra,sizeof(char),50,fichero);

	 if(!feof(fichero))
	 {
	 do
	 {
		palabra(); //llamamos a la funcion nombre para obtener su pantallita
		fflush(stdin);
		gotoxy(28,13);scanf("%[^\n]",entra_palabra);
	 }
	 while(entra_palabra[0]=='\0');
	 for(i=0;i<=strlen(entra_palabra);i++)
		{
		entra_palabra[i]=toupper(entra_palabra[i]);
		if(entra_palabra[i]=='') entra_palabra[i]='';//la cambiamos a mayusculas
		}


	 while(!ferror(fichero) && !feof(fichero))
		 {

		 if(strcmp(entra_palabra,busca_palabra)!=0)
		   {
		   fwrite(busca_palabra,sizeof(char),50,temporal);
		   }
		 else
			{
			comprobar=1;
			}

		 fread(busca_palabra,sizeof(char),50,fichero);

		 }
		 textcolor(5);
		 if(comprobar==0)
			{
			 clrscr();
			 gotoxy(22,13);cprintf("La palabra no existe en el fichero");
			 sleep(1);
			}
		 else
			{
			clrscr();
			gotoxy(25,13);cprintf("Palabra borrada con xito");
			sleep(1);
			}
		 fclose(temporal);
		 fclose(fichero);
		 remove("palabras.dat");
		 rename("temporal","palabras.dat");
	 do
	   {
	   clrscr();
		do
		{
		gotoxy(22,13);cprintf("Quieres borrar otra palabra[s/n]?:   ");
		fflush(stdin);
		gotoxy(58,13);
		_setcursortype(_NORMALCURSOR);
		opci=toupper(getche());
		_setcursortype(_NOCURSOR);
		borrarcaracter=getch();
		}
		while(borrarcaracter=='\b');//controlamos el borrado
	   }
	   while(opci!='S' && opci!='N' );
	 }
	 else
	 {
	 fclose(fichero);
	 fclose(temporal);
	 clrscr();
	 gotoxy(25,13);cprintf("No hay ninguna palabra en el fichero");
	 sleep(2);
	 return;
	 }

  }
  while(opci!='N');


}



void ver(void)
{
   int i=0;

   char aux[50];
   char palabra[50];

   FILE *fichero;
   FILE *temporal;
   FILE *temporal_malo;

   temporal_malo=fopen("temp_malo","w+b");
   temporal=fopen("temporal","w+b");
   fichero=fopen("palabras.dat","a+b");

 textattr( 56 );
 fread(aux,sizeof(char),50,fichero);
 if(!feof(fichero))
 {
	do
	{
		fread(palabra,sizeof(char),50,fichero);
		while(!ferror(fichero) && !feof(fichero))
		{


				if(strcmp(aux,palabra)<0)
				 {
					fread(palabra,sizeof(char),50,fichero);

				 }
				 else
				 {
					strcpy(aux,palabra);

					fread(palabra,sizeof(char),50,fichero);
				 }
		}

		fwrite(aux,sizeof(char),50,temporal);
		//ahora borramos aux del fichero

		rewind(fichero);
		fread(palabra,sizeof(char),50,fichero);
		while(!ferror(fichero) && !feof(fichero))
		{

			if(strcmp(palabra,aux)!=0)
			{
				fwrite(palabra,sizeof(char),50,temporal_malo);
			}
			fread(palabra,sizeof(char),50,fichero);
		}
		fclose(fichero);
		fclose(temporal_malo);
		remove("palabras.dat");
		rename("temp_malo","palabras.dat"); //con esto ya tenemos nuestro fichero sin la palabra ordenadada
		fichero=fopen("palabras.dat","a+b");
		temporal_malo=fopen("temp_malo","w+b");
		fread(aux,sizeof(char),50,fichero);
	}
	while(!ferror(fichero) && !feof(fichero));
	fclose(fichero);
	fclose(temporal_malo);
	fclose(temporal);
	remove("palabras.dat");
	remove("temp_malo");
	rename("temporal","palabras.dat");
	//ahora el fichero est ordenado y tenemos que volver a abrirlo para
	// mostrarlo en la lista
	fichero=fopen("palabras.dat","a+b");

	clrscr();
	textcolor(14);gotoxy(30,1);cprintf("Lista de palabras");
	fread(palabra,sizeof(char),50,fichero);
	i=0; //lo usamos como si fuera un |more de msdos
	while(!feof(fichero))
	{
		i++;
		if(i%21==0)
		{
			textcolor(14);gotoxy(24,24);cprintf("Pulsa cualquier tecla para seguir");
			getch();
			clrscr();
			textcolor(14);gotoxy(30,1);cprintf("Lista de palabras");
			i=1;
		}

		gotoxy(33,i+2);textcolor(5);cprintf("%s",palabra);
		fread(palabra,sizeof(char),50,fichero);
		fflush(stdin);
	}
	getch();
	fclose(fichero);
 }
 else
 {
	fclose(temporal);
	fclose(temporal_malo);
	fclose(fichero);
	clrscr();
	gotoxy(25,13);
	textcolor(5);cprintf("No hay ninguna palabra en el fichero");
	sleep(2);
	remove("temporal");
	remove("palabras.dat");
	remove("temp_malo");
 }
}










void presentacion(void)

{
	 clrscr();
	 textattr( 0 );
	 gotoxy( 17, 8 );
	 cputs( "" );
	 textattr( 0 );
	 gotoxy( 15, 9 );
	 cputs( "" );
	 textattr( 0 );
	 gotoxy( 66, 9 );
	 cputs( "" );
	 textattr( 56 );
	 textattr( 0 );
	 gotoxy( 15, 10 );
	 cputs( "" );
	 textattr( 22 );
	 gotoxy( 19, 10 );
	 cputs( "                                             " );
	 textattr( 0 );
	 gotoxy( 66, 10 );
	 cputs( "" );
	 gotoxy( 15, 11 );
	 cputs( "" );
	 textattr( 53 );
	 gotoxy( 18, 11 );
	 cputs( " " );
	 textattr( 22 );
	 gotoxy( 19, 11 );
	 cputs( " " );
	 textattr( 17 );
	 gotoxy( 20, 11 );
	 cputs( "" );
	 textattr( 22 );
	 gotoxy( 62, 11 );
	 cputs( "  " );
	 textattr( 53 );
	 gotoxy( 64, 11 );
	 cputs( "  " );
	 textattr( 0 );
	 gotoxy( 66, 11 );
	 cputs( "" );
	 textattr( 48 );
	 gotoxy( 14, 12 );
	 cputs( "  " );
	 textattr( 0 );
	 gotoxy( 17, 12 );
	 cputs( "" );
	 textattr( 53 );
	 gotoxy( 20, 12 );
	 cputs( " " );
	 textattr( 22 );
	 gotoxy( 21, 12 );
	 cputs( " " );
	 textattr( 17 );
	 gotoxy( 22, 12 );
	 cputs( "" );
	 textattr( 48 );
	 gotoxy( 25, 12 );
	 cputs( "       EL JUEGO DEL AHORCADO" );
	 gotoxy( 54, 12 );
	 cputs( " " );
	 textattr( 22 );
	 gotoxy( 60, 12 );
	 cputs( "  " );
	 textattr( 0 );
	 gotoxy( 64, 12 );
	 cputs( "" );
	 textattr( 48 );
	 gotoxy( 76, 12 );
	 cputs( "     " );
	 textattr( 0 );
	 gotoxy( 15, 13 );
	 cputs( "" );
	 textattr( 53 );
	 gotoxy( 18, 13 );
	 cputs( " " );
	 textattr( 22 );
	 gotoxy( 19, 13 );
	 cputs( " " );
	 textattr( 17 );
	 gotoxy( 20, 13 );
	 cputs( "" );
	 textattr( 48 );
	 gotoxy( 23, 13 );
	 cputs( " " );
	 textattr( 22 );
	 gotoxy( 62, 13 );
	 cputs( "  " );
	 textattr( 0 );
	 gotoxy( 66, 13 );
	 cputs( "" );
	 gotoxy( 15, 14 );
	 cputs( "" );
	 textattr( 53 );
	 gotoxy( 18, 14 );
	 cputs( " " );
	 textattr( 22 );
	 gotoxy( 19, 14 );
	 cputs( " " );
	 textattr( 17 );
	 gotoxy( 20, 14 );
	 cputs( "" );
	 textattr( 22 );
	 gotoxy( 21, 14 );
	 cputs( "                                           " );
	 textattr( 0 );
	 gotoxy( 66, 14 );
	 cputs( "" );
	 gotoxy( 15, 15 );
	 cputs( "" );
	 gotoxy( 66, 15 );
	 cputs( "" );
	 textattr( 48 );
	 gotoxy( 12, 16 );
	 cputs( "   " );
	 textattr( 0 );
	 gotoxy( 17, 16 );
	 cputs( "  " );
	 textattr( 52 );
	 gotoxy( 32, 20 );
	 cputs( "Creado por Andrs" );
	 textattr( 52 );
	 gotoxy( 36, 22 );
	 cputs( "Ao 2003" );

	 _setcursortype(_NOCURSOR);
	 sleep(2);

}

void palabra(void)
{
	 clrscr();
	 gotoxy(26,13);textcolor(0);cprintf("                        ");
	 textattr( 53 );
	 gotoxy( 24, 10 );
	 cputs( "" );
	 textattr( 94 );
	 gotoxy( 29, 10 );
	 cputs( " INTRODUZCA PALABRA: " );
	 textattr( 53 );
	 gotoxy( 49, 10 );
	 cputs( "Ŀ" );
	 gotoxy( 24, 11 );
	 cputs( "" );
	 gotoxy( 53, 11 );
	 cputs( "" );
	 gotoxy( 24, 12 );
	 cputs( "" );
	 gotoxy( 53, 12 );
	 cputs( "" );
	 gotoxy( 24, 13 );
	 cputs( "" );
	 gotoxy( 53, 13 );
	 cputs( "" );
	 gotoxy( 24, 14 );
	 cputs( "" );
	 gotoxy( 53, 14 );
	 cputs( "" );
	 gotoxy( 24, 15 );
	 cputs( "" );
	 gotoxy( 53, 15 );
	 cputs( "" );
	 gotoxy( 24, 16 );
	 cputs( "" );
}

void nombre(void)
{
	 clrscr();
	 gotoxy(26,13);textcolor(0);cprintf("                        ");
	 textattr( 53 );
	 gotoxy( 24, 10 );
	 cputs( "" );
	 textattr( 94 );
	 gotoxy( 29, 10 );
	 cputs( " INTRODUZCA NOMBRE: " );
	 textattr( 53 );
	 gotoxy( 49, 10 );
	 cputs( "Ŀ" );
	 gotoxy( 24, 11 );
	 cputs( "" );
	 gotoxy( 53, 11 );
	 cputs( "" );
	 gotoxy( 24, 12 );
	 cputs( "" );
	 gotoxy( 53, 12 );
	 cputs( "" );
	 gotoxy( 24, 13 );
	 cputs( "" );
	 gotoxy( 53, 13 );
	 cputs( "" );
	 gotoxy( 24, 14 );
	 cputs( "" );
	 gotoxy( 53, 14 );
	 cputs( "" );
	 gotoxy( 24, 15 );
	 cputs( "" );
	 gotoxy( 53, 15 );
	 cputs( "" );
	 gotoxy( 24, 16 );
	 cputs( "" );
}

void pantalla_juego(void)
{
	clrscr();
	textattr( 53 );
	gotoxy( 6, 3 );
	cputs( "Ŀ" );
     gotoxy( 6, 4 );
     cputs( "" );
	textattr( 48 );
	gotoxy( 58, 4 );
     cputs( "  " );
	textattr( 53 );
	gotoxy( 75, 4 );
	 cputs( "" );
     gotoxy( 6, 5 );
     cputs( "" );
	textattr( 94 );
	gotoxy( 27, 5 );
	 cputs( "Ŀ" );
	textattr( 52 );
	 gotoxy( 66, 5 );
	cputs( "" );
	textattr( 48 );
	gotoxy( 68, 5 );
	cputs( "     " );
	textattr( 53 );
	gotoxy( 75, 5 );
	cputs( "" );
	gotoxy( 6, 6 );
	cputs( "" );
	textattr( 94 );
	gotoxy( 27, 6 );
	cputs( "       EL AHORCADO      " );
	 textattr( 48 );
	gotoxy( 65, 6 );
	cputs( "ͻ" );
	gotoxy( 72, 6 );
	cputs( " " );
	textattr( 53 );
	gotoxy( 75, 6 );
	cputs( "" );
	textattr( 53 );
	gotoxy( 6, 7 );
	cputs( "" );
	textattr( 94 );
	gotoxy( 27, 7 );
	 cputs( "" );
	textattr( 48 );
	gotoxy( 65, 7 );
	cputs( "˼  " );
	gotoxy( 72, 7 );
	 cputs( " " );
	textattr( 53 );
	gotoxy( 75, 7 );
	 cputs( "" );
	gotoxy( 6, 8 );
	cputs( "" );
	textattr( 48 );
	gotoxy( 64, 8 );
	cputs( "˼˻" );
	gotoxy( 72, 8 );
	cputs( " " );
	textattr( 53 );
	gotoxy( 75, 8 );
	 cputs( "" );
	textattr( 53 );
	gotoxy( 6, 9 );
	cputs( "" );
	textattr( 94 );
	gotoxy( 16, 9 );
	 cputs( " NOMBRE:" );
	textattr( 48 );
	gotoxy( 64, 9 );
	cputs( "" );
	gotoxy( 68, 9 );
	 cputs( "" );
	gotoxy( 72, 9 );
	cputs( " " );
	textattr( 53 );
	gotoxy( 75, 9 );
	cputs( "" );
	gotoxy( 6, 10 );
	cputs( "" );
	textattr( 48 );
	gotoxy( 64, 10 );
	 cputs( "Ⱥ  " );
	gotoxy( 72, 10 );
	cputs( " " );
	textattr( 53 );
	gotoxy( 75, 10 );
	cputs( "" );
	gotoxy( 6, 11 );
	cputs( "" );
	textattr( 94 );
	gotoxy( 16, 11 );
	cputs( " PUNTOS:" );
	textattr( 48 );
	gotoxy( 65, 11 );
	cputs( "ɻ" );
	gotoxy( 72, 11 );
	cputs( " " );
	 textattr( 53 );
	gotoxy( 75, 11 );
	 cputs( "" );
	gotoxy( 6, 12 );
	cputs( "" );
	 textattr( 48 );
	gotoxy( 65, 12 );
	cputs( "" );
	gotoxy( 72, 12 );
	cputs( " " );
	textattr( 53 );
	gotoxy( 75, 12 );
	cputs( "" );
	gotoxy( 6, 13 );
	cputs( "" );
	textattr( 48 );
	gotoxy( 64, 13 );
	 cputs( "ͼͼ" );
	gotoxy( 72, 13 );
	cputs( " " );
	 textattr( 53 );
	gotoxy( 75, 13 );
	cputs( "" );
	gotoxy( 6, 14 );
	cputs( "" );
	textattr( 48 );
	gotoxy( 61, 14 );
	cputs( "" );
	textattr( 53 );
	gotoxy( 75, 14 );
	cputs( "" );
	gotoxy( 6, 15 );
	 cputs( "" );
	textattr( 48 );
	gotoxy( 56, 15 );
	cputs( "    " );
	 textattr( 53 );
	 gotoxy( 75, 15 );
	cputs( "" );
	gotoxy( 6, 16 );
	cputs( "" );
	textattr( 48 );
	gotoxy( 56, 16 );
	cputs( "   " );
	textattr( 53 );
	gotoxy( 75, 16 );
	cputs( "" );
	gotoxy( 6, 17 );
	cputs( "" );
	 textattr( 48 );
	gotoxy( 58, 17 );
	cputs( "" );
	textattr( 53 );
	gotoxy( 75, 17 );
	cputs( "" );
	gotoxy( 6, 18 );
	cputs( "" );
	 textattr( 53 );
	gotoxy( 75, 18 );
	cputs( "" );
	textattr( 53 );
	gotoxy( 6, 19 );
	cputs( "" );
	textattr( 53 );
	gotoxy( 75, 19 );
	cputs( "" );
	gotoxy( 6, 20 );
	cputs( "" );
	textattr( 53 );
	 gotoxy( 75, 20 );
	cputs( "" );
	gotoxy( 6, 21 );
	cputs( "" );
	textattr( 53 );
	gotoxy( 75, 21 );
	cputs( "" );
	textattr( 53 );
	gotoxy( 6, 22 );
	cputs( "" );
}

void fallo(void)
{
//static int posicion=0;

gotoxy(38+posicion,6);printf(" ");
posicion++;
gotoxy(26,17);printf("                  ");
_setcursortype(_NOCURSOR);
gotoxy(26,17);printf("FALLASTE");
sleep(1);
gotoxy(26,17);printf("        ");
if(posicion==8) posicion=0;
}




void puntuacion(void)
{
 int i=0;


   Ficha registro,aux;

   FILE *fichero;
   FILE *temporal;
   FILE *temporal_malo;

   temporal_malo=fopen("temp_malo","w+b");
   temporal=fopen("temporal","w+b");
   fichero=fopen("jugadores.dat","a+b");

 fread(&aux,sizeof(Ficha),1,fichero);
 if(!ferror(fichero) && !feof(fichero))
 {
	do
	{
		fread(&registro,sizeof(Ficha),1,fichero);
		while(!ferror(fichero) && !feof(fichero))
		{


				if(aux.puntos>registro.puntos)
				 {
					fread(&registro,sizeof(Ficha),1,fichero);

				 }
				 else
				 {
					strcpy(aux.nombre,registro.nombre);
					aux.puntos=registro.puntos;
					fread(&registro,sizeof(Ficha),1,fichero);
				 }
		}

		fwrite(&aux,sizeof(Ficha),1,temporal);
		//ahora borramos aux del fichero

		rewind(fichero);
		fread(&registro,sizeof(Ficha),1,fichero);
		while(!ferror(fichero) && !feof(fichero))
		{

			if(strcmp(registro.nombre,aux.nombre)!=0 /*&& registro.puntos!=aux.puntos*/)
			{
				fwrite(&registro,sizeof(Ficha),1,temporal_malo);
			}
			fread(&registro,sizeof(Ficha),1,fichero);
		}
		fclose(fichero);
		fclose(temporal_malo);
		remove("jugadores.dat");
		rename("temp_malo","jugadores.dat"); //con esto ya tenemos nuestro fichero sin la palabra ordenadada

		fichero=fopen("jugadores.dat","a+b");
		temporal_malo=fopen("temp_malo","w+b");
		fread(&aux,sizeof(Ficha),1,fichero);
	}
	while(!ferror(fichero) && !feof(fichero));
	fclose(fichero);
	fclose(temporal_malo);
	fclose(temporal);
	remove("jugadores.dat");
	remove("temp_malo");
	rename("temporal","jugadores.dat");

	//ahora el fichero est ordenado y tenemos que volver a abrirlo para
	// mostrarlo en la lista
	fichero=fopen("jugadores.dat","a+b");

	clrscr();
	textcolor(14);gotoxy(30,1);
	cprintf("Lista de jugadores");
	fread(&registro,sizeof(Ficha),1,fichero);
	i=0; //lo usamos como si fuera un |more de msdos
	while(!feof(fichero))
	{
		i++;
		if(i%21==0)
		{
			textcolor(14);
			gotoxy(24,24);
			cprintf("Pulsa cualquier tecla para seguir");
			getch();
			clrscr();
			textcolor(14);gotoxy(30,1);cprintf("Lista de jugadores");
			i=1;
		}

		gotoxy(10,i+2);textcolor(5);cprintf("%s",registro.nombre);
		gotoxy(60,2+i);cprintf("%d\n",registro.puntos);
		fread(&registro,sizeof(Ficha),1,fichero);
		fflush(stdin);
	}
	getch();
	fclose(fichero);
 }
 else
 {
	fclose(temporal);
	fclose(temporal_malo);
	fclose(fichero);
	remove("temporal");
	remove("temp_malo");
	remove("jugadores.dat");
	clrscr();
	textcolor(5);
	gotoxy(25,13);cprintf("No hay ningn jugador registrado");
	sleep(2);
 }
}
